package de.unibielefeld.cebitec.gi.algogr.exl2;

/**
 * Forward Algorithm.
 * 
 * @param <State>
 *            state type
 * @param <Alphabet>
 *            type of emission alphabet
 */
public class Forward<State, Alphabet> {

    private double[][] f;

    /**
     * Method that implements the Forward Algorithm
     * 
     * @param hmm
     *            HMM
     * @param x
     *            emission sequence
     * @return full probability P(x) of emission sequence x
     */
    public double run(HMM<State, Alphabet> hmm, Alphabet[] x) {

        // access required HMM data structures
        double[][] A = hmm.getTransitionMatrix();
        double[][] E = hmm.getEmissionMatrix();
        State[] Q = hmm.getStates();
        double[] alpha = hmm.getBeginDistribution();

        /*
         * FORWARD ALGORITHM
         */

        // initialize table of f variables
        this.f = new double[x.length][Q.length];

        /*
         * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         * Exercise 2: Implement the Forward algorithm by correctly filling the
         * initialized table of f variables!
         * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         */

        // START

        // INITIALIZATION (i=0)
        // TODO implement the following statement:
        // f_{begin state} (1) = 1, f_k(0) = 0 for k in Q

        // RECURSION (i=1,...,L)
        // TODO implement the following statement:
        // f_l(i) = e_l(x_i) * \sum_k (f_k(i-1) * a_{k,l})

        // TERMINATION
        // TODO implement the following statement:
        // P(x) = \sum_k f_k(L)
        double P_x = 0;

        // END

        // return P(x)
        return P_x;
    }

    /**
     * Getter for f variables.
     * 
     * @return f variables computed in run() function
     */
    public double[][] getVariables() {
        return this.f;
    }
}
